package org.gcube.data.access.storages.mock;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Map;
import java.util.UUID;

import org.apache.commons.io.IOUtils;
import org.gcube.common.storagehub.model.exceptions.StorageIdNotFoundException;
import org.gcube.common.storagehub.model.items.nodes.Content;
import org.gcube.common.storagehub.model.items.nodes.PayloadBackend;
import org.gcube.common.storagehub.model.storages.MetaInfo;
import org.gcube.common.storagehub.model.storages.StorageBackend;

public class FSStorage extends StorageBackend {

	public FSStorage(PayloadBackend payloadConfiguration) {
		super(payloadConfiguration);
	}

	@Override
	public MetaInfo onCopy(Content content, String newParentPath, String newName) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public MetaInfo onMove(Content content, String newParentPath) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void delete(String id) {
		// TODO Auto-generated method stub

	}

	@Override
	public MetaInfo upload(InputStream stream, String relativePath, String name, String user) {
		return this.upload(stream, relativePath, name, -1l, user);
	}

	@Override
	public MetaInfo upload(InputStream stream, String relativePath, String name, Long size, String user) {

		try {
			InputStream is = new BufferedInputStream(stream);
			String id = UUID.randomUUID().toString();
			File targetFile = new File("/tmp/" + id);
			targetFile.createNewFile();
			OutputStream outStream = new FileOutputStream(targetFile);

			byte[] buffer = new byte[1024 * 64];
			int bytesRead;
			while ((bytesRead = is.read(buffer, 0, 1024 * 64)) != -1) {
				outStream.write(buffer, 0, bytesRead);
			}
			IOUtils.closeQuietly(outStream);

			return new MetaInfo(targetFile.length(), id, user, getPayloadConfiguration());
		} catch (Exception e) {
			throw new RuntimeException(e);
		}

	}

	@Override
	public InputStream download(Content item) throws StorageIdNotFoundException {
		return this.download(item.getStorageId());
	}

	@Override
	public InputStream download(String id) throws StorageIdNotFoundException {
		try {
			return new FileInputStream(new File("/tmp/" + id));
		} catch (FileNotFoundException e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public Map<String, String> getFileMetadata(String id) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public MetaInfo upload(InputStream stream, String relativePath, String name, String storageId, Long size,
			String user) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getTotalSizeStored() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getTotalItemsCount() {
		// TODO Auto-generated method stub
		return null;
	}

}
