package org.gcube.data.access.storages.mock;

import jakarta.inject.Singleton;

import org.gcube.common.storagehub.model.exceptions.InvalidCallParameters;
import org.gcube.common.storagehub.model.items.nodes.PayloadBackend;
import org.gcube.common.storagehub.model.storages.StorageBackend;
import org.gcube.common.storagehub.model.storages.StorageBackendFactory;

@Singleton
public class FSStorageFactory implements StorageBackendFactory {

	@Override
	public String getName() {
		return "local-filesystem";
	}

	@Override
	public StorageBackend create(PayloadBackend payloadConfiguration) throws InvalidCallParameters {
		return new FSStorage(payloadConfiguration);
	}

}
